****************************************************************************************
* Q14_3. Friberg: Managing risk and uncertainty
* stata do-file 
* A hypothetical profit (based on price of Barley in the U.K.)
*******************************************  
clear all
cd "X:\Users\nerf\Documents\forskning\aktiva\risk_uncertainty_book\exercizes\ch14" /*replace this with your own directory where data is stored*/
use "q14_3.dta", clear
gen profit=(price-mc)*q
line profit period
scatter profit price

* question a) 
reg profit price

* question b)
* generate counterfactual values of price using regression on profit
egen maxper=max(period)   /* for some purposes below useful to have indicator for last period*/
gen lastper=0
replace lastper=1 if period==maxper
sum price
quietly set obs 1373      /*add obs for counterfactual*/
set seed 10101            /* set up the random numbers generator*/  
generate price_counterfact=rnormal(6.55,2.10)         /* generate counterfactual prices*/
replace price=price_counterfact if price==.
predict counter_profit if period>373                  /*predict counterfactual profit using regression*/
label variable counter_profit "Using regression"
hist counter_profit, saving (reg_count, replace)

* question c)
* generate counterfactual values of price using regression on profit
egen mc_count=max(mc*lastper) /* fix mc and quantity at their last values*/
egen q_count=max(q*lastper)

gen alt_counter_profit=(price_counterfact-mc_count)*q_count if period>=maxper  /* calculate counterfactuals */
label variable alt_counter_profit "Using the profit function"
hist alt_counter_profit, saving(dir_count, replace)
graph combine "reg_count" "dir_count", title("Two ways of generating counterfactual profits", style(textbookstyle)) saving(fig_comb, replace asis)

