***********************************************************
* Question 3.6 for Friberg: "Managing risk and uncertainty" 
* stata do-file 
* File to consider Box-Office revenues. Data for 2012 from the "http://www.the-numbers.com/market/2012/top-grossing-movies"
***********************************************************

clear
cd "C:\Users\nerf\Documents\forskning\aktiva\risk_uncertainty_book\exercizes\ch3" /*replace this with your own directory where data is stored*/
use q3_6, clear

* a) use a histogram to illustrate revenue
hist revenue

* b) somewhat hard to see, another way to illustrate is 
dotplot revenue, saving(dotrev, replace) 

* c) and yet another is to plot revenue against rank
scatter revenue rank

* d) examine in logs
gen lnrev=ln(revenue)
gen lnrank=ln(rank)
scatter lnrev lnrank
* or, to make it clearer
twoway (scatter lnrev rank), xscale(log) xlabel(150(100)400)

* e) try regression 
reg lnrev lnrank if rank<150

* f) for Zipf more common to specify other way around
scatter lnrank lnrev 
reg lnrank lnrev if rank<150

* g) for illustrative purposes useful to consider what things would look like if
* box office revenue were normally distributed
sum revenue
set seed 98273
gen normrev=rnormal(1.78e+07,6000000)  /*note lower sd dev than for the actual data to keep rev>0*/
hist normrev
dotplot normrev, saving(dotnormrev, replace)
graph combine "dotrev" "dotnormrev"

* h) play with rank regresssions for normal-distributed data
sort normrev
gen crank=608-_n
gen lnnormrev=ln(normrev)
gen lncrank=ln(crank)
scatter lncrank lnnormrev
twoway (scatter lnnormrev crank), xscale(log) xlabel(200(100)400)

reg lnnormrev lncrank if crank<150
